#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <pthread.h>
#include <sys/wait.h>
#include "P2PTunnelAPIs.h"
#include "IOTCAPIs.h"
#include "AVAPIs.h"
#include <errno.h>

// Enable auto launch PasswordServer.
#define LAUNCH_PASSWORD_PROC 0

char gUID[21];

int gSID_Used[20];
int gSID_StartTime[20];

// default password if no "passwd.txt" exist
char gPassword[24]="P2P Platform";

#if LAUNCH_PASSWORD_PROC
int gPassPID=0;
#endif
#define _NORMAL_
#define _ADD_SOCKET_ 
#define _ADD_AVAPI_FUNC_ 

#ifdef _ADD_AVAPI_FUNC_
	int sus_init_avmod = -1;
#endif

typedef struct st_AuthData
{
	char szUsername[64];
	char szPassword[64];
} sAuthData;

#ifdef _ADD_SOCKET_

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#define LISTEN_SIZE 20
#define BUFFER_SIZE 16384
void thread_sockethandler(void* arg)
{
	if(!arg){
		return ;
	}
	
	int temp_sock_descriptor = *(int*)arg;
	free(arg);
	char buf[BUFFER_SIZE];// 缓冲区大小
	int i,len;
	while(1){
        if(recv(temp_sock_descriptor,buf,BUFFER_SIZE,0) ==-1)
        {
            perror("call to recv");
            exit(1);
        }

        printf("received from client:%s\n",buf);
	}
    close(temp_sock_descriptor);

}

#define BUF_SIZE 1024
char buf[BUF_SIZE];

int start_server(int port)
{
    printf("enter thread_listen,port:8080\n");
    int socketfd,conned;
    int ret = -1;
    struct sockaddr_in serverAddr;
	memset(buf,0, BUF_SIZE);
    bzero(&serverAddr, sizeof(serverAddr));
    serverAddr.sin_family = AF_INET;
    serverAddr.sin_addr.s_addr = htonl(INADDR_ANY);
    serverAddr.sin_port = htons(8080);

    socketfd = socket(AF_INET,SOCK_STREAM,0);
    bind(socketfd,(struct sockaddr*)&serverAddr, sizeof(serverAddr));
    listen(socketfd,1024);
	while(1){
		if((conned = accept(socketfd,(struct sockaddr*)NULL,NULL)) == -1)
        {
            printf("accpet socket error: %s errno :%d\n",strerror(errno),errno);
            continue;
        }
		int *sckfd = (int*)malloc(sizeof(int));
		if(!sckfd) continue;
		*sckfd = conned;
		pthread_t Thread_handler_ID; 
		printf("this is a test, create thread\n");
		if((ret = pthread_create(&Thread_handler_ID, NULL, &thread_sockethandler, (void*)sckfd)))
		{
			printf("Login Thread create fail, ret=[%d]\n", ret);
			return -1;
		}
		pthread_detach(Thread_handler_ID);
   	}
	close(socketfd);
    return 0;
}

#endif

#ifdef _ADD_AVAPI_FUNC_
int InitAVAPIModule(int maxchannelnum)
{
	printf("do avInitialize(%d)\n",maxchannelnum);
	return sus_init_avmod = avInitialize(maxchannelnum);
}

void deinitAVAPIModule()
{
	printf("do avDeInitialize()\n");
	avDeInitialize();
}

int authfunc(const char *szViewAccount, const char *szViewPassword)
{
	printf("enter {%s} acc = %s,pwd = %s\n",__func__,szViewAccount,szViewPassword);
	return 1;
}

void thread_servStart(void* arg)
{
	if(!arg){
		return ;
	}
	
	int sid = *(int*)arg;
	free(arg);
	if(sid < 0){
		return ;
	}
	
	int nResend;
	int avIndex = avServStart3(sid, authfunc, 20, 0, 1, &nResend);
	printf("avServStart3 return %d\n",avIndex);
	if(avIndex < 0){
		printf("%s exit",__func__);
		return ;
	}
	unsigned int cmdType;
	char cmdbuf[1024] = {0};
	while(1){
		int ret = avRecvIOCtrl(avIndex, &cmdType, cmdbuf, 1024, 1000);
		if(ret < 0){
			if(ret == -20011 || ret == -20012){
				continue;
			}
			else{
				break;
			}
		}
		printf("avRecvIOCtrl recv io data,cmdType = 0x%x\n",cmdType);
	}
	
	printf("avServStop(%d)...\n",avIndex);
	avServStop(avIndex);	
	avIndex = -1;
}

#endif

void TunnelStatusCB(int nErrorCode, int nSID, void *pArg)
{
	if(nErrorCode == TUNNEL_ER_DISCONNECTED)
	{
		printf("SID[%d] TUNNEL_ER_DISCONNECTED Log file here!\n", nSID);
		P2PTunnelServer_Disconnect(nSID);
		gSID_Used[nSID] = 0;
		if(pArg != NULL)
			printf("MyArg = %s\n", (char *)pArg);
	}
}

void *Thread_TestCloseSession(void *arg)
{
	pthread_detach(pthread_self());
	
	int SID = *((int *)arg);
	free(arg);
	srand(time(NULL));
    int nDelayTime = rand() % 60;
    printf("nDelayTime to close[%d]\n", nDelayTime);
	sleep(nDelayTime);
	printf("P2PTunnelServer_Disconnect SID[%d] ret[%d]\n", SID, P2PTunnelServer_Disconnect(SID));
	
	return 0;
}

int TunnelSessionInfoCB(sP2PTunnelSessionInfo *sSessionInfo, void *pArg)
{
	printf("TunnelSessionInfoCB trigger\n");
	if(pArg != NULL) printf("pArg = %s\n", (char *)pArg);
	printf("[Client Session Info]\n");
	printf("  Connection Mode = %d, NAT type = %d\n", sSessionInfo->nMode, sSessionInfo->nNatType);
	printf("  P2PTunnel Version = %X, SID = %d\n", (unsigned int)sSessionInfo->nVersion, sSessionInfo->nSID);
	printf("  IP Address = %s:%d\n", sSessionInfo->szRemoteIP, sSessionInfo->nRemotePort);
	
	if(sSessionInfo->nAuthDataLen == 0 || sSessionInfo->pAuthData == NULL)
		return -777;
	else if(sSessionInfo->nAuthDataLen > 0)
	{
		FILE *pfd = fopen("passwd.txt","r");
		if(pfd!=NULL)
		{
			int len=0;
			memset(gPassword, 0, sizeof(gPassword));
			//int ret = fread(gPassword, 1, sizeof(gPassword)-1, pfd);
			if ( fgets(gPassword, sizeof(gPassword), pfd) == NULL )
			{
			}

			len = strlen(gPassword);
			if(len>0 && gPassword[len-1]=='\n')
				gPassword[len-1] = '\0';
			fclose(pfd);
		}
		sAuthData *pAuthData = (sAuthData *)sSessionInfo->pAuthData;
		printf("  Auth data length = %d, username = %s, passwd = %s\n", sSessionInfo->nAuthDataLen, pAuthData->szUsername, pAuthData->szPassword);
		if(strcmp(pAuthData->szUsername, "Tutk.com") != 0 || strcmp(pAuthData->szPassword, gPassword) != 0)
			return -888;
	}
	gSID_Used[sSessionInfo->nSID] = 1;
	gSID_StartTime[sSessionInfo->nSID] = time(NULL);
	if(P2PTunnel_SetBufSize(sSessionInfo->nSID, 5120000) < 0)
		printf("P2PTunnel_SetBufSize error SID[%d]\n", sSessionInfo->nSID);
	
	#if 0 // test random time to close session
	int *SID = (int *)malloc(sizeof(int));
	if(SID != NULL)
	{
		*SID = sSessionInfo->nSID;
		pthread_t threadID;
		pthread_create(&threadID, NULL, &Thread_TestCloseSession, (void *)SID);
	}
	#endif
	
#ifdef _ADD_AVAPI_FUNC_ // add AVAPI
	int *SID = (int *)malloc(sizeof(int));
	if(SID != NULL)
	{
		*SID = sSessionInfo->nSID;
		pthread_t threadID;
		int ret = -1;
		if(ret = pthread_create(&threadID, NULL, &thread_servStart, (void *)SID)){
			printf("servstart Thread create fail, ret=[%d]\n", ret);
			return -1;
		}
		pthread_detach(threadID);
	}
#endif

	return 0;
}

#if LAUNCH_PASSWORD_PROC
// Clean up Password setting process.
void clean_up_passd(int sig)
{
	printf("Clean up PasswordServer process.\n");
	waitpid(gPassPID, 0, WNOHANG);
}
#endif

int main(int argc, char *argv[])
{
	int errCode =0, retry=0;
	if(argc < 2)
	{
		printf("No UID input!!!\n");
		return 0;
	}
	
	strcpy(gUID, argv[1]);
	int i;
	for(i=0;i<20;i++)
		gSID_Used[i]=0;

#if LAUNCH_PASSWORD_PROC		
	// create password process
	// note: you can launch process manually, depend on your product.
	gPassPID = fork();
	if(gPassPID==0)	//child process
	{
		printf("PasswordServer Created!!\n");
		execlp("./PasswordServer", "PasswordServer", "9000",NULL);
		exit(0);
	}
	signal(SIGCHLD, clean_up_passd);
	printf("PasswordServer PID=%d\n", gPassPID);
#endif
	
	
	char *s = "My arg Pass to call back function";
	P2PTunnelServer_GetStatus(TunnelStatusCB, (void *)s);
	printf("Tunnel Version[%X]\n", P2PTunnel_Version());
	int ret = P2PTunnelServerInitialize(20);
	if(ret < 0)
	{
		printf("P2PTunnelServerInitialize error[%d]!\n", ret);
		return -1;
	}
#ifdef _ADD_AVAPI_FUNC_
	if(ret = InitAVAPIModule(32) < 0){
		printf("InitAVAPIModule error:%d\n",ret);
		return -1;
	}
#endif
	/* If you don't want to use authentication mechanism, you can give NULL argument
	ret = P2PTunnelServer_GetSessionInfo(TunnelSessionInfoCB, NULL);
	*/
	ret = P2PTunnelServer_GetSessionInfo(TunnelSessionInfoCB, (void *)s);
	
	printf("Call P2PTunnelServer_GetSessionInfo ret[%d]\n", ret);
	
	errCode = P2PTunnelServer_Start(gUID);
	if( errCode<0 )
	{
		// No Internet
		if( errCode == IOTC_ER_SERVER_NOT_RESPONSE || errCode == IOTC_ER_NETWORK_UNREACHABLE )
			printf("No Internet, error[%d]!! Reconnect after 15sec...\n", errCode);
		else
		{
			printf("P2PTunnelServer_Start error[%d]!\n", errCode);
			return -1;
		}
	}
	else
		printf("P2PTunnelServer_Start Success, I can connected by Internet.\n");
	
	while(1)
	{
#ifdef _ADD_SOCKET_
	start_server(8080);
#else
		for(i=0; i<20; i++)
		{
			if(gSID_Used[i])
			{
				int access_time = P2PTunnel_LastIOTime(i);
				if(access_time < 0)
				{
					printf("P2PTunnel_LastIOTime Error Code %d\n", access_time);
					gSID_Used[i] = 0;
				}
				else
					printf("SID %d:%u, ", i, access_time);
				end =1;
			}
		}
		sleep(1);		
#endif
	}
#ifdef _ADD_AVAPI_FUNC_
	deinitAVAPIModule();
#endif
	return 0;
}

